<?php
ob_start();
$cookie_name = "number_of_time";
$cookie_value = "";

if (!isset($_COOKIE[$cookie_name]))
	{
	$cookie_value = 0;
	setcookie($cookie_name, $cookie_value, time() + (86400 * 30) , "/"); // 86400 = 1 day
	}

if (!class_exists("RecentOrders")):
	class RecentOrders

		{
		function __construct()
			{
			$this->init();
			}

		function init()
			{
			add_action('wp_enqueue_scripts', array(
				$this,
				'front_stylesheet'
			));
			register_activation_hook(__FILE__, array(
				$this,
				'activate'
			));
			add_filter('woocommerce_settings_tabs_array', array(
				$this,
				'add_setting_tab'
			));
			add_action('woocommerce_settings_recent_order_widget', array(
				$this,
				'show_tab'
			));
			add_action('woocommerce_settings_tabs_recent_order_widget', array(
				$this,
				'show_options'
			));
			add_action('woocommerce_update_options_recent_order_widget', array(
				$this,
				'save_options'
			));
			add_action('woocommerce_checkout_after_customer_details', array(
				$this,
				'live_sales_feed_checkout_option'
			));
			add_action('woocommerce_checkout_update_order_meta', array(
				$this,
				'live_sales_feed_update_order_meta'
			));
			add_action('woocommerce_admin_order_data_after_order_details', array(
				$this,
				'live_sales_feed_admin_checkout_option'
			));
			add_shortcode('live_sales_feed', array(
				$this,
				'recent_order'
			));
			add_action('wp_ajax_ajax_recent_order', array(
				$this,
				'ajax_recent_order'
			));
			add_action('wp_ajax_nopriv_ajax_recent_order', array(
				$this,
				'ajax_recent_order'
			));
			add_action('wp_footer', array(
				$this,
				'action_wp_footer'
			));
			add_action('admin_enqueue_scripts', array(
				$this,
				'admin_enqueue'
			));
			}

		function front_stylesheet()
			{
			wp_enqueue_script('notification', plugins_url('/js/notification.js', __FILE__) , array(
				'jquery'
			) , '1.0');
			wp_register_style('front-style', plugins_url('/css/front.css', __FILE__));
			wp_register_style('animate', plugins_url('/css/animate.css', __FILE__));
			wp_enqueue_style('front-style');
			wp_enqueue_style('animate');
			wp_register_script('front-js', plugins_url('/js/car-jquery.js', __FILE__) , array(
				'jquery'
			));
			wp_enqueue_script('front-js');
			}

		function activate()
			{
			add_option('woocommerce_no_of_order', '5', '', 'yes');
			add_option('display_customer_name', 'yes', '', 'yes');
			add_option('display_lfcity', 'yes', '', 'yes');
			add_option('display_product_name', 'yes', '', 'yes');
			add_option('display_product_image', 'yes', '', 'yes');
			add_option('display_time', 'yes', '', 'yes');
			add_option('selected_order_status', 'all', '', 'yes');
			}

		function add_setting_tab($data)
			{
			$data['recent_order_widget'] = __('Live Sales Feed', 'appzab-woo-live-sales-feed');
			return $data;
			}

		function get_setting_data()
			{
			global $woocommerce;
			$number_of_views = get_option('number_of_views');
			$number_of_views++;
			$order_statuses = array();
			if (version_compare($woocommerce->version, '2.2.0', '<'))
				{
				$order_status_terms = get_terms('shop_order_status', array(
					'hide_empty' => false
				));
				if (!is_wp_error($order_status_terms))
					{

					// $order_status_terms = array();

					foreach($order_status_terms as $term)
						{
						$order_statuses[$term->slug] = $term->name;
						}
					}
				}
			  else
				{
				$order_statuses = wc_get_order_statuses();
				}

			$woocommerce_settings = array(
				array(
					'title' => __('Live Sales Feed', 'appzab-woo-live-sales-feed') ,
					'type' => 'title',
					'desc' => 'Configure settings for Live Sales Feed. You can use shortcode [live_sales_feed] to place widget on any page. You can also exclude popups from showing up on any page, post or product individually by editing that page, post or product. Refer to plugin documentation for instructions to translate.',
					'id' => 'recent_order_widget_option'
				) ,
				array(
					'title' => __('No. Of Orders to Show', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'woocommerce_no_of_order',
					'type' => 'number',
					'css' => 'width:50px;',
					'default' => '5',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('No. Of Orders to Show', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'woocommerce_no_of_order_widget',
					'type' => 'number',
					'css' => 'width:50px;',
					'default' => '5',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
                array(
					'title' => __("Enable Popup Notification", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'popup_notifier',
					'default' => 'no',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					) ,
				) ,
				array(
					'name' => __('Order Status to include in Feed', 'appzab-woo-live-sales-feed') ,
					'id' => 'selected_order_status',
					'class' => 'chosen_select',
					'css' => 'width:400px;',
					'type' => 'multiselect',
					'default' => array(
						'wc-completed',
						'wc-processing'
					) ,
					'options' => $order_statuses,
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'name' => __('Order Status to include in Feed', 'appzab-woo-live-sales-feed') ,
					'id' => 'selected_order_status_widget',
					'class' => 'chosen_select',
					'css' => 'width:400px;',
					'type' => 'multiselect',
					'default' => array(
						'wc-completed',
						'wc-processing'
					) ,
					'options' => $order_statuses,
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __('Display Customer\'s First Name', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_first_name',
					'default' => 'true',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('Display Customer\'s First Name', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_first_name_widget',
					'default' => 'true',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __('Display Customer\'s Last Name', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_last_name',
					'default' => 'true',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('Display Customer\'s Last Name', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_last_name_widget',
					'default' => 'true',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __('Display "Someone" instead of customer\'s real name', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_someone_name',
					'default' => 'false',
					'show_if_checked' => true,
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('Display "Someone" instead of customer\'s real name', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_someone_name_widget',
					'default' => 'false',
					'show_if_checked' => true,
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __('Display City', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_lfcity',
					'default' => 'yes',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('Display City', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_lfcity_widget',
					'default' => 'yes',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __('Display Product Name', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_product_name',
					'default' => 'yes',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('Display Product Name', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_product_name_widget',
					'default' => 'yes',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __('Display Product Image', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_product_image',
					'default' => 'yes',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('Display Product Image', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_product_image_widget',
					'default' => 'yes',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __("Display Time", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'display_time',
					'default' => 'yes',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('Display Order totals', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'show_order_totals',
					'default' => 'true',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('Display Order totals', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'show_order_totals_widget',
					'default' => 'true',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __('Scroll Interval', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'wc_feed_scroll_interval',
					'default' => '2000',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __('Carousel items to see', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'wc_feed_scroll_items',
					'default' => '3',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __('Carousel height', 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'wc_feed_scroll_height',
					'default' => '375',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __("Direction", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'wc_feed_widget_direction',
					'default' => 'up',
					'type' => 'select',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					) ,
					'options' => array(
						'up' => 'Up',
						'right' => 'Right',
						'left' => 'Left',
						'down' => 'Down',
					)
				) ,
				array(
					'title' => __("Order Sequence", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'wc_feed_ordertype',
					'default' => 'rand',
					'type' => 'select',
					'options' => array(
						'rand' => 'Random',
						'DESC' => 'DESC',
						'ASC' => 'ASC',
					) ,
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Order Sequence", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'wc_feed_ordertype_widget',
					'default' => 'rand',
					'type' => 'select',
					'options' => array(
						'rand' => 'Random',
						'DESC' => 'DESC',
						'ASC' => 'ASC',
					) ,
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				
				array(
					'title' => __("Delay Time", 'appzab-woo-live-sales-feed') ,
					'desc' => __('How long a popup stays on the screen of your visitor (in milliseconds)', 'appzab-woo-live-sales-feed') ,
					'id' => 'deplay_time',
					'default' => '5000',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Delay first notification", 'appzab-woo-live-sales-feed') ,
					'desc' => __('delay first notification for x seconds after the site is opened for first time.', 'appzab-woo-live-sales-feed') ,
					'id' => 'deplay_first_time',
					'default' => '10000',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Number of times", 'appzab-woo-live-sales-feed') ,
					'desc' => "Show popup to a visitor only 'x' number of times. This should be some finite number.",
					'id' => 'visitor_number_of_time',
					'default' => '0',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Show purchased x time ago on Popup?", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'show_bought_ago_lf',
					'default' => 'yes',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Show purchased x time ago on widget?", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'show_bought_ago_lf_widget',
					'default' => 'yes',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __("Popup Border Radius", 'appzab-woo-live-sales-feed') ,
					'desc' => 'If you want to add some style to your popups',
					'id' => 'wc_feed_popup_border',
					'default' => '0px',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Popup Opacity", 'appzab-woo-live-sales-feed') ,
					'desc' => 'Should be between 0 and 1',
					'id' => 'popup_opacity',
					'default' => '1',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __('Delay between popups', 'appzab-woo-live-sales-feed') ,
					'desc' => 'Time in milliseconds between two popups',
					'id' => 'wc_feed_delay_between_popups_appear',
					'default' => '10000',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Disable on Mobile devices?", 'appzab-woo-live-sales-feed') ,
					'desc' => 'Popups are responsive but if you wish to disable them, simply check this option',
					'id' => 'popup_notifier_mobile',
					'default' => 'no',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Google Analytics UTM Parameter URL", 'appzab-woo-live-sales-feed') ,
					'desc' => 'eg. ?utm_source=livesalesfeed&utm_medium=popup&utm_campaign=livepromo. This will append to the product URL in popup',
					'id' => 'custom_html',
					'default' => '?utm_source=livesalesfeed&utm_medium=popup&utm_campaign=livepromo',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Google Analytics UTM Parameter URL", 'appzab-woo-live-sales-feed') ,
					'desc' => 'eg. ?utm_source=livesalesfeed&utm_medium=widget&utm_campaign=livepromo. This will append to the product URL in popup',
					'id' => 'custom_html_widget',
					'default' => '?utm_source=livesalesfeed&utm_medium=widget&utm_campaign=livepromo',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#widget'
					)
				) ,
				array(
					'title' => __("Popup Position", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'location_show_popup',
					'default' => 'leftbutton',
					'type' => 'select',
					'options' => array(
						1 => 'Top Left',
						2 => 'Top Right',
						3 => 'Bottom Right',
						4 => 'Bottom Left',
					) ,
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Popup Effect", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'show_popup_effect',
					'default' => 'fadeIn',
					'type' => 'select',
					'options' => array(
						'fadeIn' => 'fadeIn',
						'zoomIn' => 'zoomIn',
						'fadeOutDown' => 'fadeOutDown',
						'bounceOutDown' => 'bounceOutDown',
						'flipInY' => 'flipInY',
						'zoomOut' => 'zoomOut',
						'swing' => 'swing',
						'flash' => 'flash'
					) ,
					'custom_attributes' => array(
						'data-tab' => '#popup'
					)
				) ,
				array(
					'title' => __("Enable Customer Permission on Checkout page?", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'id' => 'customer_permission_lf',
					'default' => 'no',
					'type' => 'checkbox',
					'custom_attributes' => array(
						'data-tab' => '#global'
					)
				) ,
				array(
					'title' => __("Permission text for checkout page", 'appzab-woo-live-sales-feed') ,
					'desc' => '',
					'css' => 'width:450px;',
					'id' => 'wc_feed_checkout_text',
					'default' => 'Include my information in Live Sales Feed',
					'type' => 'text',
					'custom_attributes' => array(
						'data-tab' => '#global'
					)
				) ,
				array(
					'type' => 'sectionend',
					'id' => 'recent_order_widget_option'
				) ,
			);
			return $woocommerce_settings;
			}

		function show_tab()
			{
			$widget_url = "'" . admin_url('admin.php?page=wc-settings&tab=recent_order_widget&subtab=widget') . "'";
			$popup_url = "'" . admin_url('admin.php?page=wc-settings&tab=recent_order_widget&subtab=popup') . "'";
			$global_url = "'" . admin_url('admin.php?page=wc-settings&tab=recent_order_widget&subtab=global') . "'";
			echo '<ul id="livesale" class="subsubsub"><li><a href="#widget" onclick="return admin_setting.redirect(' . $widget_url . ');" >' . __('Widget Settings', 'appzab-woo-live-sales-feed') . '</a> | </li><li><a href="#popup" onclick="return admin_setting.redirect(' . $popup_url . ');" class="">' . __('Popup Settings', 'appzab-woo-live-sales-feed') . '</a> | </li><li><a href="#global"  onclick="return admin_setting.redirect(' . $global_url . ');" class="">' . __('Global Settings', 'appzab-woo-live-sales-feed') . '</a>   </li></ul><br/>';
			echo '<input type="hidden" name="_wp_current_tab"  value="' . $_GET['subtab'] . '" />';
			}

		function admin_enqueue($hook)
			{
			if ('woocommerce_page_wc-settings' != $hook)
				{
				return;
				}

			wp_enqueue_script('admin-js', plugins_url('/js/adminjs.js', __FILE__));
			}

		function show_options()
			{
			$data = $this->get_setting_data();
			woocommerce_admin_fields($data);
			}

		function save_options()
			{
			$data = $this->get_setting_data();
			woocommerce_update_options($data);
			$reset_click = get_option('reset_click');
			if ($reset_click == "yes")
				{
				update_option('number_of_click', 0);
				update_option('reset_click', "");
				}

			$reset_view = get_option('reset_view');
			if ($reset_view == "yes")
				{
				update_option('number_of_views', 0);
				update_option('reset_view', "");
				}
			}

		function recent_order()
			{
			$query_args = $this->buildQueryArgs('widget');

			// print_r($query_args);

			global $post;
			$postid = $post->ID;
			$live_sale_feed = get_post_meta(get_the_ID() , 'live-sales-feed-disable', true);
			$query = new WP_Query($query_args);
			if ($query->have_posts())
				{
?>

                <script type="text/javascript" language="javascript">

                    jQuery(function () {

                        var $c = jQuery('#carousel'),

                            $w = jQuery(window);

                        $c.carouFredSel({

                            items: <?php
				print get_option('wc_feed_scroll_items'); ?>,

                            height: <?php
				print get_option('wc_feed_scroll_height'); ?>,

                            direction: "<?php
				print get_option('wc_feed_widget_direction'); ?>",

                            scroll: {

                                items: 1,

                                duration: <?php
				print get_option('wc_feed_scroll_interval'); ?>,

                                pauseOnHover: 'immediate',

                                timeoutDuration: 2000

                            },

                        });

                    });

                    var ajaxurl = "<?php
				echo admin_url('admin-ajax.php'); ?>";



                    // setInterval('abc()', 25000);



                    function abc() {

                        jQuery.ajax({

                            type: 'POST',

                            url: ajaxurl,

                            dataType: 'json',

                            data: {'action': 'ajax_recent_order'},

                            success: function (data) {




                                // alert(data.result);
                                // jQuery('#carousel').empty();



                                jQuery('#carousel').html(data.result);



                                // jQuery("ul#carousel > li:lt(5)").remove();



                            }


                        });

                    }

                </script>

                <div style="clear:all;">


                    <ul class="prdct-list" id="carousel">

                        <?php
				while ($query->have_posts()):
					$query->the_post();
					global $product, $post;
					if ('0000-00-00 00:00:00' == $post->post_date)
						{
						$t_time = $h_time = __('Unpublished', 'appzab-woo-live-sales-feed');
						}
					  else
						{
						$t_time = get_the_time(__('d/m/Y g:i:s A', 'appzab-woo-live-sales-feed') , $post);
						$gmt_time = strtotime($post->post_date_gmt);
						$time_diff = current_time('timestamp', 1) - $gmt_time;
						if ($time_diff > 0 && $time_diff < 24 * 60 * 60) $h_time = sprintf(__('%s ago', 'woocommerce') , human_time_diff($gmt_time, current_time('timestamp', 1)));
						  else $h_time = get_the_time(__('d/m/Y', 'appzab-woo-live-sales-feed') , $post);
						}

					$order = new WC_Order(get_the_ID());
					if (sizeof($order->get_items()) > 0):
						$item = current($order->get_items());
						$_product = $order->get_product_from_item($item);
						if (!is_object($_product)) continue;
?>

                                <li>

                                    <div class="prdct-img">

                                        <?php
						if (get_option('display_product_image_widget') == 'yes')
							{ ?>

                                            <div class="div-left">

                                                <a class="pr-img" href="<?php
							echo esc_url(get_permalink($item['product_id'])); ?>"> <?php
							echo $_product->get_image('shop_thumbnail', array(
								'title' => ''
							)); ?> </a>

                                            </div>

                                            <?php
							} ?>

                                        <div class="div-right">

                                            <?php
						if (get_option('display_product_name_widget') == 'yes')
							{ ?>

                                                <a class="pr-tit" href="<?php
							echo esc_url(get_permalink($item['product_id']) . get_option('custom_html_widget')); ?>"> <?php
							echo esc_attr($_product->get_title()); ?> </a>

                                                <?php
							$pl = ($order->get_item_count() - 1) > 1 ? ' Items' : ' Item';
							$more = ($order->get_item_count() > 1) ? '&nbsp;+&nbsp;' . ($order->get_item_count() - 1) . $pl : '<br />';
							echo "<span class='more'>" . $more . "</span>"; ?>

                                                <?php
							} ?>

                                            <div>

                                                    <span class="label-two"> <?php
						$lfbought = __('Bought by', 'appzab-woo-live-sales-feed'); ?>

                                                        <?php
						printf(__('%s') , $lfbought); ?>
                                                        <?php
						if (get_option('display_someone_name_widget') == 'yes'):
							print __('someone', 'appzab-woo-live-sales-feed') . ' ';
						else:
							if (get_option('display_first_name_widget') == 'yes'): ?>

                                                                <?php
								echo esc_html($order->billing_first_name) . ' '; ?>

                                                                <?php
							endif; ?>

                                                            <?php
							if (get_option('display_last_name_widget') == 'yes'): ?>

                                                                <?php
								echo esc_html($order->billing_last_name); ?>

                                                                <?php
							endif;
						endif; ?>

                                                        <?php
						if (get_option('display_lfcity_widget') == 'yes')
							{ ?>

                                                            from <?php
							echo esc_html($order->billing_city); ?>

                                                            <?php
							} ?>

                                                    </span>

                                            </div>

                                            <?php
						if (get_option('show_order_totals_widget') == 'yes'): ?>

                                                <?php
							printf("Total order for %.2f %s<br/>", $order->get_total() , $order->get_order_currency()); ?>

                                                <?php
						endif; ?>

                                            <?php
						if (get_option('show_bought_ago_lf_widget') == 'yes')
							{ ?>

                                                <span class="ticker-time"> <?php
							echo esc_attr($h_time); ?></span>

                                                <?php
							} ?>

                                        </div>

                                    </div>

                                </li>

                                <?php
					endif;
				endwhile;
?>

                    </ul>

                </div>

                <?php
				}

			wp_reset_postdata();
			}

		function ajax_recent_order()
			{
			global $post;
			$postid = $post->ID;
			$live_sale_feed = get_post_meta(get_the_ID() , 'live-sales-feed-disable', true);
			$query_args = $this->buildQueryArgs('popup');
			$query = new WP_Query($query_args);
			if ($live_sale_feed != "true")
				{
				if ($query->have_posts())
					{
					while ($query->have_posts()):
						$query->the_post();
						global $product, $post;
						if ('0000-00-00 00:00:00' == $post->post_date)
							{
							$t_time = $h_time = __('Unpublished', 'appzab-woo-live-sales-feed');
							}
						  else
							{
							$t_time = get_the_time(__('d/m/Y g:i:s A', 'appzab-woo-live-sales-feed') , $post);
							$gmt_time = strtotime($post->post_date_gmt);
							$time_diff = current_time('timestamp', 1) - $gmt_time;
							if ($time_diff > 0 && $time_diff < 24 * 60 * 60) $h_time = human_time_diff($gmt_time, current_time('timestamp', 1));
							$h_time = get_the_time(__('d/m/Y', 'appzab-woo-live-sales-feed') , $post);
							}

						$order = new WC_Order(get_the_ID());
						if (sizeof($order->get_items()) > 0):
							$item = current($order->get_items());
							$_product = $order->get_product_from_item($item);
							$out.= '<li><div class="prdct-img">';
							if (get_option('display_product_image') == 'yes')
								{
								$out.= '<div class="div-left"><a class="pr-img" href="' . esc_url(get_permalink($item['product_id'])) . '">' . $_product->get_image('shop_thumbnail', array(
									'title' => ''
								)) . '</a></div>';
								}

							$out.= '<div class="div-right">';
							if (get_option('display_product_name') == 'yes')
								{
								$out.= '<a class="pr-tit" href="' . esc_url(get_permalink($item['product_id'])) . '">' . esc_attr($_product->get_title()) . '</a>';
								$pl = ($order->get_item_count() - 1) > 1 ? ' Items' : ' Item';
								$more = ($order->get_item_count() > 1) ? '&nbsp;+&nbsp;' . ($order->get_item_count() - 1) . $pl : '<br />';
								$out.= "<span class='more'>" . $more . "</span>";
								}

							$out.= '<div><span class="label-two">';
							if (get_option('display_customer_name') == 'yes')
								{
								$out.= 'Bought by ' . esc_html($order->billing_first_name) . ' ' . esc_html($order->billing_last_name);
								}

							if (get_option('display_lfcity') == 'yes')
								{
								$out.= '&nbsp;from ' . esc_html($order->billing_city);
								}

							$out.= '</span></div>';
							if (get_option('display_time') == 'yes')
								{
								$out.= '<span class="ticker-time">' . esc_attr($h_time) . '</span>';
								}

							$out.= '</div></div></li>';
						endif;
					endwhile;
					}

				wp_reset_postdata();
				echo json_encode(array(
					'result' => $out
				));
				die();
				}
			}

		function live_sales_feed_checkout_option()
			{
			global $woocommerce;
			if (get_option('customer_permission_lf', 'no') != 'yes') echo '<style type="text/css"> #live_sales_feed_option_field{ display: none; } </style>';
			/*return false;*/
			$lfinclude = get_option('wc_feed_checkout_text');
			echo '<div id="my-new-field">';
			woocommerce_form_field('live_sales_feed_option', array(
				'type' => 'checkbox',
				'class' => array(
					'input-checkbox'
				) ,
				'label' => $lfinclude,
			) , 1);
			echo '</div><br/>';
			}

		function live_sales_feed_update_order_meta($order_id)
			{
			if ($_POST['live_sales_feed_option'])
				{
				update_post_meta($order_id, 'show_order_option', esc_attr($_POST['live_sales_feed_option']));
				}
			  else
				{
				update_post_meta($order_id, 'show_order_option', 2);
				}
			}

		function live_sales_feed_admin_checkout_option($order)
			{
			$option = get_post_meta($order->id, 'show_order_option', true);
			$val = empty($option) ? null : $option;
			if ($val == 1 || !($val))
				{
				$chk = "checked=checked";
				}

			echo '<p class="form-field form-field-wide">

                <input type="checkbox" ' . $chk . ' id="live_sales_feed_option" name="live_sales_feed_option" style="width:0%">Include information in the Live Sales Feed

                </p>';
			}

		protected
		function buildQueryArgs($type)
			{
			$query_type = '';
			if ($type == 'widget')
				{
				$query_type = '_widget';
				}

			$c = count(get_option('selected_order_status' . $query_type));
			$query_args = array(
				'post_type' => 'shop_order',
				'posts_per_page' => ($type == 'widget') ? get_option('woocommerce_no_of_order_widget') : get_option('woocommerce_no_of_order') ,
				'orderby' => 'ID',
				'order' => ($type == 'widget') ? get_option('wc_feed_ordertype_widget') : get_option('wc_feed_ordertype')
			);
			if ($type == 'widget')
				{
				$type = '_widget';
				}
			  else
				{
				$type = '';
				}

			if (get_option('wc_feed_ordertype' . $type) == 'rand')
				{
				$query_args['orderby'] = ($type == 'widget') ? get_option('wc_feed_ordertype_widget') : get_option('wc_feed_ordertype');
				}

			if (get_option('selected_order_status' . $query_type) == 'all' || $c == 0)
				{
				if (version_compare(WC()->version, '2.2.0', '<'))
					{

					// print "woocommerce <= 2.1.0";

					$query_args['post_status'] = 'publish';
					$query_args['meta_query'] = array(
						'relation' => 'OR',
						array(
							'key' => 'show_order_option',
							'compare' => 'NOT EXISTS',
							'value' => ''
						) ,
						array(
							'key' => 'show_order_option',
							'value' => 1
						)
					);
					}

				/*
				  else
				{
				$statuses = get_option('selected_order_status');

				// print "woocommerce > 2.1.0";

				$query_args['post_status'] = array_shift($statuses);
				}

				*/
				}
			  else
				{
				if (version_compare(WC()->version, '2.2.0', '<'))
					{

					// print "woocommerce <= 2.1.0";

					$query_args['post_status'] = 'publish';
					$query_args['meta_query'] = array(
						'relation' => 'OR',
						array(
							'key' => 'show_order_option',
							'compare' => 'NOT EXISTS',
							'value' => ''
						) ,
						array(
							'key' => 'show_order_option',
							'value' => 1
						)
					);
					$tax_query = array(
						'taxonomy' => 'shop_order_status',
						'field' => 'slug',
						'terms' => get_option('selected_order_status' . $query_type) ,
						'operator' => 'IN'
					);
					$query_args['tax_query'] = array(
						$tax_query
					);
					}
				  else
					{
					$statuses = get_option('selected_order_status' . $query_type);

					// print "woocommerce > 2.1.0";

					$query_args['post_status'] = $statuses;
					$query_args['meta_query'] = array(
						'relation' => 'OR',
						array(
							'key' => 'show_order_option',
							'compare' => 'NOT EXISTS',
							'value' => ''
						) ,
						array(
							'key' => 'show_order_option',
							'value' => 1
						)
					);
					}
				}

			// print_r($query_args);

			return $query_args;
			}

		public

		function action_wp_footer()
			{
			global $post;
			$postid = $post->ID;
			$live_sale_feed = get_post_meta(get_the_ID() , 'live-sales-feed-disable', true);
			if ($live_sale_feed != "true")
				{
				$number_of_views = get_option('number_of_views');
				$number_of_views++;

				// update_option( 'number_of_views', $number_of_views);

				$cookie_name = "number_of_time";
				if ((get_option('visitor_number_of_time') > $_COOKIE[$cookie_name]) || (get_option('visitor_number_of_time') == 0))
					{
					$cookie_value = intval($_COOKIE[$cookie_name]) + 1;
					setcookie($cookie_name, $cookie_value, time() + (86400 * 30) , "/"); // 86400 = 1 day
					if ($live_sale_feed != "true")
						{
						global $woocommerce;
						if (get_option('popup_notifier', 'no') != 'yes') return false;
						if (isset($_COOKIE['wc_feed_closed'])) return false;
						$args = $this->buildQueryArgs('popup');
						$query = new WP_Query($args);
						if (!$query->have_posts()) return false;
						$opacity = (float)get_option('popup_opacity');
						$pborder = get_option('wc_feed_popup_border');
?>

                        <style>
                            @media screen  and (max-width: 480px) {
                                .live-sale-notify {
                                    left: 0px !important;
                                    width: 100% !important;
                                }

                                @media screen  and (max-width: 400px) {
                                    .live-sale-notify text {
                                        width: 80% !important;
                                    }

                                    @media screen  and (max-width: 350px) {
                                        .live-sale-notify div.text {
                                            width: 70% !important;
                                            height: 92px !important;
                                        }
                                    }
                                }

                            }

                            .live-sale-notify {

                                background: none repeat scroll 0 0 #FFFFFF;

                                border: 0 none;

                                border-radius: <?php
						print $pborder; ?>px;

                                box-shadow: 0 0 2px 0 rgba(0, 0, 0, 0.4);

                                font-family: Arial, sans-serif;

                                font-size: 12px;


                                margin-right: 30px;

                                padding-right: 10px;

                                text-align: left;

                                width: auto;

                                height: 90px;

                                z-index: 99999;

                                bottom: -100%;

                                overflow: hidden;

                                bottom: -90px;

                                opacity: <?php
						print $opacity; ?>

                            }

                            .live-sale-notify  {

                                list-style-type: none;

                                margin: 0;

                                display: block;

                            }

                            .live-sale-notify div {



                                background-color: #fff;

                            }

                            .live-sale-notify {

                                background-color: #fff;

                            }

                            .live-sale-notify div.text {

                                padding: 0;

                                text-align: left;

                                vertical-align: middle;

                            }

                            .live-sale-notify img {

                                float: left;

                                margin-left: 10px;

                                height: 80px;

                                width: auto;

                                position: relative;

                                overflow: hidden;

                                margin-right: 10px;

                                margin-top: 5px;
                                margin-bottom: 5px;

                            }

                            .caroufredsel_wrapper .div-left {

                                margin-left: 15px;

                            }

                            .caroufredsel_wrapper .div-right {

                                float: left !important;

                            }

                            .live-sale-notify td {
                                border: 0px !important;
                            }

                            .live-sale-notify .wc_feed_close_btn {
                                display: block;
                                position: absolute;
                                width: 16px;
                                height: 16px;
                                top: 2px;
                                right: 2px;
                                background-image: url(" <?php
						get_site_url(); ?>/wp-content/plugins/appzab-woo-live-sales-feed/images/close-lf.png");
                            }

                            <?php
						if (get_option('popup_notifier_mobile') == 'yes'): ?>

                            @media screen and (max-width: 480px) {

                                .live-sale-notify {

                                    display: none;

                                }

                            }

                            <?php
						endif;
						$showtime = get_option('deplay_time');
						$popup_effect = get_option('show_popup_effect');
						$location_show_popup = get_option('location_show_popup');
						$showfirsttime = get_option('deplay_first_time');
						$number_of_time = get_option('visitor_number_of_time');
?>


                        </style>

                        <script type="text/javascript">


                            /* jQuery(document).ready(function($) {



                             jQuery(".live-sale-notify a").click(function(){





                             var data = {

                             action: 'live_sale_feed_click',

                             my_var: 'my_data'

                             };



                             jQuery.post( ajaxurl, data, function(response) {



                             });

                             })



                             });

                             */

                        </script>

                        <script>

                            var interval = null;

                            var current_index = -1;

                            var sales_feeds = [];

                            var showtime = <?php
						echo $showtime; ?>;
                            var showfirsttime = <?php
						echo $showfirsttime; ?>;

                            var number_of_time = <?php
						echo $number_of_time; ?>;

                            var visible_times = 0;

                            <?php
						$s = get_option('wc_feed_delay_between_popups_appear');
						if (!$s)
							{
							$s = 1000;
							}

?>



                            function hide_prev_feed_notify(index) {

                                if (sales_feeds.eq(current_index).length > 0) {

                                    sales_feeds.eq(current_index).animate({bottom: '-90px'}, 500);

                                }

                            }


                            function show_live_feed_notify(index,showtime) {
                             var content = sales_feeds.eq(index).html();

                           Notification.create(content,'<?php
						echo $popup_effect; ?>',<?php
						echo $location_show_popup; ?>,showtime/1000);


                                // sales_feeds.eq(index).animate({bottom: '10px'}, 1000);



                                current_index = index;

                            }

                            function show_next_live_notify() {

                                visible_times++;

                                if ((current_index + 1) >= sales_feeds.length) {
                                    current_index = -1;
                                }

                                if (window.console)

                                    console.log('will show ' + (current_index + 1));


                                if (visible_times <= number_of_time) {

                                    show_live_feed_notify(current_index + 1,showtime);
                                }
                                  else {
                                    var data = {

                                        action: 'live_sale_feed_view',

                                        number_of_time: number_of_time

                                    };

                                    jQuery.post(ajaxurl, data, function (response) {

                                    });

                                    jQuery('.wc_feed_close_btn').trigger('click');
                                }

                            }

                            function stop_live_notify() {

                                removeInterval(inverval);

                            }

                            function readCookie(name) {

                                var nameEQ = escape(name) + "=";

                                var ca = document.cookie.split(';');

                                for (var i = 0; i < ca.length; i++) {

                                    var c = ca[i];

                                    while (c.charAt(0) === ' ') c = c.substring(1, c.length);

                                    if (c.indexOf(nameEQ) === 0) return unescape(c.substring(nameEQ.length, c.length));

                                }

                                return null;

                            }

                            jQuery(function () {

                                jQuery('.wc_feed_close_btn').click(function () {

                                    var days = 30;

                                    var date = new Date();

                                    date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));

                                    if (window.console)

                                        console.log(date.toGMTString());

                                    document.cookie = 'wc_feed_closed=true; expires=' + date.toGMTString() + ';';

                                    jQuery('.live-sale-notify').css('display', 'none');

                                    clearInterval(interval);

                                    return false;

                                });


                                sales_feeds = jQuery('.live-sale-notify');

                                setTimeout(function () {
                                    show_next_live_notify();
                                    interval = setInterval(show_next_live_notify, (showtime + <?php
						print $s + 100; ?>));
                                }, showfirsttime);
                            });

                        </script>

                        <?php
						$countries = WC()->countries->countries; //;WC()->countries->get_countries();
						while ($query->have_posts())
							{
							$query->the_post();
							global $post;
							$order = new WC_Order(get_the_ID());
							if (count($order->get_items()) <= 0) continue;
							$item = current($order->get_items());
							$_product = $order->get_product_from_item($item);
							if (!is_object($_product)) continue;
							$url = esc_url(get_permalink($item['product_id']));
							$img = $_product->get_image('shop_thumbnail', array(
								'title' => ''
							));

							// $time_elapsed = time_elapsed_string('@' . strtotime($order->order_date));

							$gmt_time = strtotime($post->post_date_gmt);
							$time_diff = current_time('timestamp', 1) - $gmt_time;
							/*if ($time_diff > 0 && $time_diff < 24 * 60 * 60) {
							$time_elapsed = sprintf(__('%s ago', 'woocommerce') , human_time_diff($gmt_time, current_time('timestamp', 1)));
							} else {
							$time_elapsed = get_the_time(__('d/m/Y', 'woocommerce') , $post);
							}*/
							$time_elapsed = human_time_diff($gmt_time, current_time('timestamp', 1));
?>


                            <?php
							$lfbought = get_option('wc_feed_boughtby_text'); ?>

                            <div class="live-sale-notify">


                            <div class="illustration"> <?php
							if (get_option('display_product_image') == 'yes')
								{ ?><?php
								echo '<input type="hidden" value="1" id="display_product_image">';
								print $img; ?>
                                <?php
								}
							  else
								{
								echo '&nbsp;';
								echo '<input type="hidden" value="0" id="display_product_image">';
								} ?></div>

                                        <div clas="text">

                                                <div class="title" style="margin-right: 20px; !important;"><a href="<?php
							print $url . get_option('custom_html'); ?>"><?php
							print $_product->get_title(); ?></a><?php
							$title = ($order->get_item_count() - 1 > 0) ? ' + ' . ($order->get_item_count() - 1) . ' ' . __('items', 'appzab-woo-live-sales-feed') : '';
							print $title; ?></div>

                                                <div class="text">

                                                    <?php
							printf(__('%s') , $lfbought); ?>

                                                    <?php
							if (get_option('display_someone_name') == 'yes'):
								print __('someone', 'appzab-woo-live-sales-feed') . ' ';
							else:
								if (get_option('display_first_name') == 'yes'): ?>

                                                            <?php
									echo esc_html($order->billing_first_name) . ' '; ?>

                                                            <?php
								endif; ?>

                                                        <?php
								if (get_option('display_last_name') == 'yes'): ?>

                                                            <?php
									echo esc_html($order->billing_last_name); ?>

                                                            <?php
								endif;
							endif;
?>

                                                    <?php
							if (get_option('display_lfcity') == 'yes')
								{ ?>

                                                        from <?php
								echo esc_html($order->billing_city); ?>

                                                        <?php
								} ?>

                                                </div>
                                                <?php
							if (get_option('show_order_totals') == 'yes'): ?>
                                            <div class="text"> <span style="font-size:80%;">
                                                <?php
								printf("Total order for %.2f %s<br/>", $order->get_total() , $order->get_order_currency()); ?></span>
                                                    </div>
                                                    <?php
							endif; ?>
                                                <?php
							if (get_option('show_bought_ago_lf') == 'yes'): ?>
                                                    <div class="text" style="margin-bottom: 18px !important;">
                                                        <span style="font-size:80%;"><?php
								printf(__('%s', 'appzab-woo-live-sales-feed') , $time_elapsed); ?></span>
                                                    </div>
                                                    <?php
							endif; ?>



                                        </div>
                                <div class="dismiss wc_feed_close_btn">&nbsp;</div>

                            </div>


                            <?php
							}
						}
					}
				}
			}
		}

endif;

function time_elapsed_string($datetime, $full = false)
	{
	$now = new DateTime;
	$ago = new DateTime($datetime);
	$diff = $now->diff($ago);
	$diff->w = floor($diff->d / 7);
	$diff->d-= $diff->w * 7;
	$string = array(
		'y' => 'year',
		'm' => 'month',
		'w' => 'week',
		'd' => 'day',
		'h' => 'hour',
		'i' => 'minute',
		's' => 'second',
	);
	foreach($string as $k => & $v)
		{
		if ($diff->$k)
			{
			$v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
			}
		  else
			{
			unset($string[$k]);
			}
		}

	if (!$full) $string = array_slice($string, 0, 1);
	return $string ? implode(', ', $string) . ' ago' : 'just now';
	}

add_action('wp_ajax_live_sale_feed_click', 'live_sale_feed_click_callback');

function live_sale_feed_click_callback()
	{

	// Do whatever you need with update_option() here.
	// You have full access to the $_POST object.

	$number_of_click = get_option('number_of_click');
	$number_of_click++;
	update_option('number_of_click', $number_of_click);
	die();
	}

add_action('wp_ajax_live_sale_feed_view', 'live_sale_feed_view_callback');

function live_sale_feed_view_callback()
	{

	// Do whatever you need with update_option() here.
	// You have full access to the $_POST object.

	$number_of_views = get_option('number_of_views');
	$number_of_views++;
	update_option('number_of_views', $number_of_views);
	$cookie_name = "number_of_time";
	$cookie_value = intval($_POST['number_of_time']) + 1;
	setcookie($cookie_name, $cookie_value, time() + (86400 * 30) , "/"); // 86400 = 1 day
	die();
	}
